Attribute VB_Name = "Module2"
'//
'// Module Columns
'//

'// Delay between frames (ms.) //
Public t As Long
'// Pauses (ms.) //
Public p As Long

'// Screen //
Public Screen() As Integer                 ' Screen vector (13 rows * 6 columns)
Public Delete() As Integer                 ' Deleted objects vector (13 rows * 6 columns)
Public Piece(0 To 3) As Byte               ' Piece vector
Public rowPiece As Integer                 ' Piece row (top object)
Public colPiece As Integer                 ' Piece column

'// Hi-Scores table //
Public Type HiScType
    hsName As String                       ' = Player initials
    hsLevel As Byte                        ' = Level
    hsScore As Long                        ' = Score
End Type
Public HighScores(1 To 10) As HiScType     ' Hi-Scores table

'// Game variables //
Public Running As Boolean                  ' App if running
Public Mode As Integer                     ' = MODE_SPLASH / MODE_GAME

Public Level As Integer                    ' Level up = speed up
Public LevelsIncreased As Integer          ' Level count
Public Score As Long                       ' Score
Public HighScore As Long                   ' Highest score
Public PlayingEffect As Boolean            ' Play flag

'// Game constants //
Public Const MODE_SPLASH = 1               ' Splash mode: Instructions
Public Const MODE_GAME = 2                 ' Playing mode
Public Const MODE_PAUSED = 3               ' Game paused
                                            
'// Splash //
Public Instructions As String              ' Instructions text
Public yText As Integer                    ' Instructions text y position

'// Init App /////////////////////////////////////////////////////////////////////////////////
Public Sub Initialize(Form As Form)


    ' Set window size and show it
    Form.Width = 640 * 15: Form.Height = 480 * 15
    Form.WindowState = vbNormal
    Form.Show
    
    ' This programm is running
    Running = True
    
    ' Load High-Scores table...
    LoadHighScores
    
    ' Initialize Splash mode
    Dim NL: NL = Chr(13) & Chr(10)
    yText = Form.iScreen.ScaleHeight + 25
    
    Instructions = "Use cursor keys:" & NL & NL & _
                   "[Left/Right] move" & NL & NL & _
                   "[Up] change/continue" & NL & NL & _
                   "[Down] quick fall" & NL & NL & _
                   "and" & NL & NL & _
                   "[Control] pause" & NL & NL & _
                   "* * *" & NL & NL & NL & _
                   "Scoring:"
    
    ' Set splash mode
    Mode = MODE_SPLASH
    
End Sub

'// Init screen //////////////////////////////////////////////////////////////////////////////
Public Sub ClearScreen()
    
    ReDim Screen(-3 To 16, -1 To 6)
    ReDim Delete(0 To 12, 0 To 5)
    
    Dim I
    
    ' Walls
    For I = -3 To 15
        Screen(I, -1) = -1
        Screen(I, 6) = -1
    Next I
    
    ' Floor
    For I = 0 To 5
        Screen(13, I) = -1
    Next I
    
    frmMain.iTemp.Cls
    
End Sub

'// Hi-Scores ////////////////////////////////////////////////////////////////////////////////

'// Load HighScores //
Public Sub LoadHighScores()
    
    Dim HiScFileName As String, FF As Integer
    HiScFileName = App.Path & "\HighScores.dat"
        
    FF = FreeFile
    
    Open HiScFileName For Binary As #FF
    Get #FF, , HighScores()
    Close #FF

End Sub

'// Save HighScores //
Public Sub SaveHighScores()
    
    Dim HiScFileName As String, FF As Integer
    HiScFileName = App.Path & "\HighScores.dat"
        
    FF = FreeFile
    
    Open HiScFileName For Binary As #FF
    Put #FF, , HighScores()
    Close #FF

End Sub

'// Checks if last score is a new high-score //
Public Function IsHighScore(Score As Long) As Integer
    
    IsHighScore = 0 ' Ret = 0 (No high-score)
    
    Dim I As Integer, J As Integer
   
    For I = 1 To 10
        If Score > HighScores(I).hsScore Then
            For J = 10 To I + 1 Step -1
                HighScores(J).hsName = HighScores(J - 1).hsName
                HighScores(J).hsLevel = HighScores(J - 1).hsLevel
                HighScores(J).hsScore = HighScores(J - 1).hsScore
            Next J
            ' Ret = Index (New high-score)
            IsHighScore = I
            HighScores(I).hsName = ""
            HighScores(I).hsLevel = Level
            HighScores(I).hsScore = Score
            Exit For
        End If
    Next I
        
End Function





